import * as React from "react";
import { calendarType } from './objectFn';
import { ICommonInterface } from "./calendar";
declare type Props = {
    field: string;
    rotate?: ICommonInterface["rotate"];
    style?: 1 | 2;
    time?: boolean;
    noInp?: boolean;
    defaultTime?: string;
    width?: number;
    placeholder?: string;
    ableClear?: boolean;
    initTime?: {
        time: string;
    };
    renderCallBack?: boolean;
    noChangeRotate?: boolean;
    clickBack: (timeStr: string, field: string, rotate: ICommonInterface["rotate"], selTimeList: States["selTimeArr"]) => void | boolean;
};
declare type States = {
    preRotate: Props['rotate'];
    preInitTime: Props['initTime'];
    expand: boolean;
    selTimeArr: IImmutalbeList<ICommonInterface["showTimeObj"]>;
    calendarVal: string;
    rotate: ICommonInterface["rotate"];
    showViewArr: ("fadeIn" | "fadeOut")[];
};
declare type fixProps = {
    style: 1 | 2;
    time: boolean;
    noChangeRotate: boolean;
};
interface ICalendar {
    curTime: ICommonInterface["curTime"];
    fixProps: fixProps;
    changeBasicState: ICommonInterface["changeBasicState"];
    createFixProps(): fixProps;
    getShowViewArr(rotate: ICommonInterface["rotate"]): States["showViewArr"];
}
declare class Calendar extends React.PureComponent<Props, States> implements ICalendar {
    static defaultProps: {
        rotate: calendarType;
        style: number;
        defaultTime: string;
        width: number;
        placeholder: string;
    };
    static getDerivedStateFromProps(nextProps: Props, preState: States): Partial<States> | null;
    curTime: {
        year: number;
        searson: number;
        month: number;
        day: number;
        hour: number;
        minute: number;
    };
    wrapDomRef: React.RefObject<HTMLDivElement>;
    fixProps: {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    constructor(props: Props);
    getShowViewArr(rotate: ICommonInterface["rotate"]): ("fadeIn" | "fadeOut")[];
    compareTimeRang(selTimeArr: States["selTimeArr"], viewIndex: number, showTimeObj: ICommonInterface["curTime"], rotate: ICommonInterface["rotate"], time: boolean): boolean;
    changeBasicState: <K extends "expand" | "selTimeArr" | "calendarVal" | "rotate" | "showViewArr" | "preRotate" | "preInitTime">(key: K, callback: (states: States) => States[K], obj?: {
        showTimeObj: {
            year: number;
            searson: number;
            month: number;
            day: number;
            hour: number;
            minute: number;
        };
        viewIndex: number;
    } | undefined) => boolean | undefined;
    createFixProps(): {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    documentClickFn: (e: MouseEvent) => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    timeStrToNumber(strArr: string[]): string[];
    getSelTimeVal(): string;
    render(): JSX.Element;
}
export default Calendar;
