import * as React from "react";
import { activeStatus, DropItem } from "./DropItem";
import ParTreeItem from "./ParTreeItem";
import wrapComboHQC from "./ComboBasic";
import { CheckBox, Search } from "../input/index";
import { formatterTreeData, cascade } from './formatterTreeData';
class DropTree extends React.PureComponent {
    constructor(props) {
        super(props);
        this.clickItem = (id) => {
            if (!id) {
                this.clear();
            }
            else {
                const { data, oldSelectedIndex } = formatterTreeData(this.props, id, this.props.data);
                this.setState({
                    immutableData: data,
                    oldSelectedIndex,
                });
            }
        };
        this.searchFn = (key) => {
            const { filedObj, data, selected } = this.props;
            const childField = filedObj.get("childField");
            const textField = filedObj.get("textField");
            const copyData = JSON.parse(JSON.stringify(data));
            let searchReswult = this.searchMap(copyData, childField, key, textField);
            const defaultVal = selected.map(val => val.id).join(",");
            const { data: immutableData, oldSelectedIndex } = formatterTreeData(this.props, defaultVal, searchReswult, true);
            this.setState({
                immutableData,
                oldSelectedIndex,
            });
        };
        this.clickFnForTreeMethod = (path) => {
            this.clickFn(path);
        };
        this.checkMethod = (path) => {
            this.checkFn(path);
        };
        this.checkForPar = (value) => {
            this.checkForParFn(value);
        };
        this.closeFn = () => {
            const { data, selected } = this.props;
            const defaultVal = selected.map(val => val.id).join(",");
            const { data: immutableData, oldSelectedIndex } = formatterTreeData(this.props, defaultVal, data, true);
            this.setState({
                immutableData,
                oldSelectedIndex
            });
        };
        this.toggleExpand = (index) => {
            const { filedObj } = this.props;
            let indexArr = index.split(",");
            indexArr = indexArr.join(`,${filedObj.get("childField")},`);
            indexArr = indexArr.split(",");
            this.setState(pre => {
                const data = pre.immutableData;
                const _data = data.updateIn(indexArr, (node) => {
                    if (!node) {
                        return;
                    }
                    const expand = !node.get("expand");
                    const _node = node.set("expand", expand);
                    return _node;
                });
                return {
                    immutableData: _data,
                };
            });
        };
        this.state = this.initState(props);
        const { clickMethod } = props;
        clickMethod(this.clickItem);
    }
    static getDerivedStateFromProps(nextProps, preState) {
        if (nextProps.data !== preState.preData || nextProps.initComboVal !== preState.preInitComboVal) {
            let initComboVal = nextProps.initComboVal;
            initComboVal = initComboVal ? initComboVal.id : "";
            const { data, oldSelectedIndex } = formatterTreeData(nextProps, `${initComboVal}`, nextProps.data);
            return {
                immutableData: data,
                oldSelectedIndex,
                preData: nextProps.data,
                preInitComboVal: nextProps.initComboVal
            };
        }
        else {
            return null;
        }
    }
    initState(props) {
        const defaultVal = props.filedObj.get("defaultVal") || "";
        const obj = formatterTreeData(props, defaultVal, props.data);
        return {
            immutableData: obj.data,
            preData: props.data,
            preInitComboVal: props.initComboVal,
            oldSelectedIndex: obj.oldSelectedIndex
        };
    }
    clear() {
        const { data, oldSelectedIndex } = formatterTreeData(this.props, "", this.props.data);
        this.setState({
            immutableData: data,
            oldSelectedIndex
        });
    }
    searchMap(data, childField, key, textField) {
        return data.filter(val => {
            const itemText = val[textField];
            const isContainer = itemText.includes(key);
            const child = val[childField];
            if (child && child.length) {
                if (isContainer) {
                    return true;
                }
                else {
                    const arr = this.searchMap(child, childField, key, textField);
                    val[childField] = arr;
                    return arr.length;
                }
            }
            else {
                return isContainer;
            }
        });
    }
    clickFn(index) {
        const { filedObj, selected, changeSelect } = this.props;
        const multipy = filedObj.get("multiply");
        const idField = filedObj.get("idField");
        const textField = filedObj.get("textField");
        const childField = filedObj.get("childField");
        const clickForbid = filedObj.get("clickOrCheckForbid");
        const comField = filedObj.get("field");
        const indexArr = index
            .split(",")
            .join(`,${childField},`)
            .split(",");
        const indexArrString = indexArr.join(",");
        this.setState(pre => {
            const data = pre.immutableData;
            let oldSelectedIndex = pre.oldSelectedIndex;
            let _data = data;
            let _select = selected;
            let newNode = _data.getIn(indexArr);
            if (!newNode) {
                return null;
            }
            if (clickForbid(newNode, comField)) {
                return null;
            }
            if (oldSelectedIndex === indexArrString) {
                return null;
            }
            if (oldSelectedIndex) {
                _data = _data.updateIn(oldSelectedIndex.split(","), (val) => {
                    return val.set("active", activeStatus.noSelect);
                });
            }
            _select = _select.clear();
            _data = _data.updateIn(indexArr, (val) => {
                const active = val.get("active") === activeStatus.select
                    ? activeStatus.noSelect
                    : activeStatus.select;
                if (active === activeStatus.select) {
                    _select = _select.push({
                        id: val.get(idField),
                        text: val.get(textField),
                    });
                }
                else {
                    if (multipy) {
                        _select = _select.filter(_val => {
                            return _val.id !== val.get(idField);
                        });
                    }
                }
                const node = val.set("active", active);
                newNode = node;
                return node;
            });
            changeSelect(_select, newNode);
            return {
                immutableData: _data,
                oldSelectedIndex: indexArrString
            };
        });
    }
    checkFn(value) {
        const { filedObj, selected } = this.props;
        const childField = filedObj.get("childField");
        const idField = filedObj.get("idField");
        const textField = filedObj.get("textField");
        const clickForbid = filedObj.get("clickOrCheckForbid");
        const comField = filedObj.get("field");
        const indexArr = value
            .split(",")
            .join(`,${childField},`)
            .split(",");
        this.setState(pre => {
            const data = pre.immutableData;
            let _data = data;
            let _select = selected;
            let newNode = _data.getIn(indexArr);
            if (!newNode) {
                return null;
            }
            if (clickForbid(newNode, comField)) {
                return null;
            }
            _data = _data.updateIn(indexArr, (val) => {
                const active = val.get("active") === activeStatus.select
                    ? activeStatus.noSelect
                    : activeStatus.select;
                if (active === activeStatus.select) {
                    _select = _select.push({
                        id: val.get(idField),
                        text: val.get(textField),
                    });
                }
                else {
                    _select = _select.filter(_val => {
                        return _val.id !== val.get(idField);
                    });
                }
                const node = val.set("active", active);
                newNode = node;
                return node;
            });
            _data = cascade(value, _data, childField);
            this.props.changeSelect(_select, newNode);
            return {
                immutableData: _data,
            };
        });
    }
    mapFn(list, active, select, filedObj) {
        let _select = select;
        const { idField, childField, textField } = filedObj;
        const arr = list.map(val => {
            let _child = val.get(childField);
            let _node = val;
            if (_child.size) {
                const result = this.mapFn(_child, active, _select, filedObj);
                _node = _node.set(childField, result.arr);
                _select = result.selecte;
            }
            else {
                if (active === activeStatus.select) {
                    if (_node.get("active") === activeStatus.select) {
                        _select = _select.filter(_val => {
                            return _val.id !== _node.get(idField);
                        });
                    }
                    _select = _select.push({
                        id: _node.get(idField),
                        text: _node.get(textField),
                    });
                }
                else {
                    _select = _select.filter(_val => {
                        return _val.id !== _node.get(idField);
                    });
                }
            }
            return _node.set("active", active);
        });
        return {
            arr: arr,
            selecte: _select,
        };
    }
    checkForParFn(value) {
        const { filedObj, selected } = this.props;
        const childField = filedObj.get("childField");
        const idField = filedObj.get("idField");
        const textField = filedObj.get("textField");
        const clickForbid = filedObj.get("clickOrCheckForbid");
        const comField = filedObj.get("field");
        const indexArr = value
            .split(",")
            .join(`,${childField},`)
            .split(",");
        this.setState(pre => {
            const data = pre.immutableData;
            let _data = data;
            let _select = selected;
            let newNode = _data.getIn(indexArr);
            if (!newNode) {
                return null;
            }
            if (clickForbid(newNode, comField, selected)) {
                return null;
            }
            _data = _data.updateIn(indexArr, (val) => {
                let node = val;
                const active = node.get("active") === activeStatus.select
                    ? activeStatus.noSelect
                    : activeStatus.select;
                node = node.withMutations(map => {
                    let _child = map.get(childField);
                    let _map = map;
                    const result = this.mapFn(_child, active, selected, {
                        idField,
                        childField,
                        textField,
                    });
                    _map = _map.set(childField, result.arr);
                    _map = _map.set("active", active);
                    _select = result.selecte;
                    return _map;
                });
                newNode = node;
                return node;
            });
            _data = cascade(value, _data, childField);
            this.props.changeSelect(_select, newNode);
            return {
                immutableData: _data,
            };
        });
    }
    render() {
        const { immutableData } = this.state;
        const { filedObj, dropStyle, formatterDropItem } = this.props;
        const idField = filedObj.get("idField");
        const childField = filedObj.get("childField");
        const multiply = filedObj.get("multiply");
        const com = immutableData.map((node, index) => {
            const child = node.get(childField);
            const id = node.get(idField);
            return child.size ? (React.createElement(ParTreeItem, { key: id, node: node, fieldObj: filedObj, clickFn: this.clickFnForTreeMethod, index: `${index}`, lev: 0, formatterDropItem: formatterDropItem, checkForPar: this.checkForPar, checkMethod: this.checkMethod, toggleExpand: this.toggleExpand })) : (React.createElement(DropItem, { key: id, node: node, fieldObj: filedObj, index: `${index}`, checkMethod: this.checkMethod, formatterDropItem: formatterDropItem, lev: 0, clickFn: this.clickFnForTreeMethod, CheckBox: multiply ? CheckBox : undefined }));
        });
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { style: { paddingBottom: "0.5em", } },
                React.createElement(Search, { field: "search", searchHandle: this.searchFn, closeHandle: this.closeFn })),
            React.createElement("ul", { style: dropStyle, className: "drop-ul" }, com)));
    }
}
export { DropTree };
export default wrapComboHQC(DropTree, "tree");
