import * as React from "react";
import CrashPage from './CrashPage';
import notice from '../toast/index';
export default class ErrorBoundary extends React.Component {
    constructor() {
        super(...arguments);
        this.state = { hasError: false };
        this.reload = () => {
            this.setState({
                hasError: false
            });
        };
    }
    static getDerivedStateFromError(error) {
        console.log(error);
        return { hasError: true };
    }
    componentDidCatch(_error, _info) {
        notice.add("数据操作出错，点击按钮重新加载页面！", "warn", true);
    }
    render() {
        if (this.state.hasError) {
            return React.createElement(CrashPage, { reloadFn: this.reload });
        }
        else {
            return this.props.children;
        }
    }
}
