import * as React from "react";
import { SvgIcon } from "../my-icon/index";
class CheckBox extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {};
        this.clickFn = (e) => {
            e.stopPropagation();
        };
    }
    render() {
        const { type, name, value, hasChecked, checked, changeHandle, children, disabled } = this.props;
        const className = checked ? "checkbox-marked" : hasChecked ? "checkbox-has-selected" : "checkbox-blank";
        return (React.createElement("label", { className: `m-label m-lab-${type}` },
            React.createElement("span", { className: "wrap-icon" },
                React.createElement(SvgIcon, { className: className, size: "middle" }),
                React.createElement("input", { type: type, className: "checkBox-inp", name: name, checked: checked, value: value, onClick: this.clickFn, onChange: changeHandle, disabled: disabled })),
            children));
    }
}
CheckBox.defaultProps = {
    type: "checkbox",
};
export default CheckBox;
