import * as ReactDom from "react-dom";
import * as React from "react";
class Loading extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            show: true,
        };
        this.toggle = (show) => {
            this.setState(pre => ({
                show: show === undefined ? !pre.show : show,
            }));
        };
    }
    render() {
        const { show } = this.state;
        return (React.createElement("div", { className: `g-loading ${!show ? "hide-loading" : ""}` },
            React.createElement("div", { className: "m-loading" },
                React.createElement("b", { className: "loading-text" }, "loading..."))));
    }
}
let loadingRef = null;
const createLoad = function (callback) {
    const wrap = document.getElementById("wrap-loading");
    ReactDom.render(React.createElement(Loading, { ref: ref => (loadingRef = ref) }), wrap, function () {
        if (callback) {
            callback();
        }
    });
};
const loadfn = {
    open: function () {
        if (!loadingRef) {
            createLoad(function () {
                loadingRef.toggle(true);
            });
        }
        else {
            loadingRef.toggle(true);
        }
    },
    close: function () {
        if (loadingRef) {
            loadingRef.toggle(false);
        }
    },
};
export { createLoad };
export default loadfn;
