import * as React from "react";
import * as ReactDom from "react-dom";
import { VelocityComponent } from "velocity-react";
import { Icon } from "../my-icon/index";
export default class Modal extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.wrap = document.getElementById("wrap-modal");
        this.modalDom = React.createRef();
        this.init = this.props.show;
        this.state = {
            pointX: 0,
            pointY: 0,
        };
        this.headMouseDown = (e) => {
            const modalDom = (this.modalDom.current);
            const { pointY, pointX } = this.state;
            const diffPointX = e.clientX - pointX;
            const diffPointY = e.clientY - pointY;
            modalDom.onmousemove = (originE) => {
                this.setState({
                    pointX: (originE.clientX - diffPointX),
                    pointY: (originE.clientY - diffPointY),
                });
            };
        };
        this.clickFn = () => {
            const { onCancel, field } = this.props;
            onCancel(field);
        };
        this.headMouseUp = () => {
            (this.modalDom.current).onmousemove = null;
        };
    }
    componentWillReceiveProps(props) {
        if (props.show !== this.props.show) {
            this.init = true;
        }
    }
    render() {
        const { children, wrap, tit, show, className, footer } = this.props;
        const { pointX, pointY } = this.state;
        const init = this.init;
        const styleObj = { transform: `translate(${pointX}px, ${pointY}px)`, };
        const container = wrap ? wrap : this.wrap;
        return init ? ReactDom.createPortal((React.createElement(VelocityComponent, { runOnMount: true, animation: show ? "transition.bounceDownIn" : "transition.bounceDownOut" },
            React.createElement("div", { className: `g-modal ${className}`, ref: this.modalDom, onMouseUp: this.headMouseUp },
                React.createElement("div", { className: "m-Mwrap" },
                    React.createElement("div", { className: "m-Mask" }),
                    React.createElement("div", { className: "m-Modal", style: styleObj },
                        React.createElement("div", { className: "m-Mtit", onMouseDown: this.headMouseDown },
                            React.createElement("span", { className: "tit-name" }, tit),
                            React.createElement("span", { className: "m-Mclose", onClick: this.clickFn },
                                React.createElement(Icon, { className: "fa fa-times fa-2x" }))),
                        React.createElement("div", { className: "m-Mbody" }, children),
                        React.createElement("div", { className: "m-Mfooter" }, footer)))))), container) : React.createElement("span", null);
    }
}
