import * as React from "react";
import { CheckBox } from "../input/index";
const TdCheckBox = ({ changeFn, index, checked }) => {
    return (React.createElement("td", null,
        React.createElement(CheckBox, { checked: checked, value: index, changeHandle: changeFn })));
};
class TBody extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.isSameTr = "";
        this.selectfn = () => {
            console.log(3);
        };
        this.checkFn = (e) => {
            const dom = e.currentTarget;
            const value = dom.value;
            const checked = dom.checked;
            const { tableData, changeHandle } = this.props;
            const newData = tableData.setIn([value, "checked"], checked);
            changeHandle("tableData", newData);
        };
    }
    componentWillReceiveProps(nexrProps) {
        if (nexrProps.tableData !== this.props.tableData) {
            this.isSameTr = "";
        }
    }
    getCheckCom(checkbox) {
        return checkbox ? TdCheckBox : () => React.createElement(React.Fragment, null);
    }
    render() {
        const { perNums, curPage, fileObj, tableData } = this.props;
        const { idField, tabField, column, checkbox, noPageNums } = fileObj;
        const startIndex = (curPage - 1) * perNums;
        const curData = (!noPageNums
            ? tableData.slice(startIndex, startIndex + perNums)
            : tableData);
        const CheckBoxOrNull = this.getCheckCom(checkbox);
        return curData.map((dataItem, index) => {
            const order = `${startIndex + 1 + index}`;
            const checked = dataItem.get("checked");
            const selected = checked ? "selected" : undefined;
            const trCom = column.map(node => {
                const { field, formatter, isRowSpanField } = node;
                const text = formatter
                    ? formatter(dataItem, order, tabField)
                    : dataItem.get(field);
                if (isRowSpanField) {
                    const _textName = dataItem.get(field);
                    if (this.isSameTr === _textName) {
                        return undefined;
                    }
                    else {
                        this.isSameTr = _textName;
                        const rowspanNum = curData
                            .slice(index)
                            .findIndex(val => {
                            return val.get(field) !== this.isSameTr;
                        });
                        const rowSpan = rowspanNum === -1 ? curData.size : rowspanNum;
                        return (React.createElement("td", { key: field, rowSpan: rowSpan }, text));
                    }
                }
                else {
                    return (React.createElement("td", { key: field, "data-index": order, onClick: field === "opt" ? this.selectfn : undefined }, text));
                }
            });
            return (React.createElement("tr", { key: dataItem.get(idField), className: selected },
                React.createElement(CheckBoxOrNull, { checked: checked, changeFn: this.checkFn, index: `${index + startIndex}` }),
                React.createElement("td", null,
                    order,
                    " "),
                trCom));
        });
    }
}
export default TBody;
